OGRE: Ogre::PanelOverlayElement Class Reference - OGRE Documentation

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | Static Protected Attributes

# Ogre::PanelOverlayElement Class Reference
[Overlays]

OverlayElement representing a flat, single-material (or transparent) panel which can contain other elements. More...

`#include <OgrePanelOverlayElement.h>`

Inheritance diagram for Ogre::PanelOverlayElement:
[legend]

List of all members.

## Classes
class | CmdTiling
| Command object for specifying tiling (see ParamCommand). More...
class | CmdTransparent
| Command object for specifying transparency (see ParamCommand). More...
class | CmdUVCoords
| Command object for specifying UV coordinates (see ParamCommand). More...
## Public Types
typedef map< String, OverlayElement * >::type | ChildMap
typedef MapIterator< ChildMap > | ChildIterator
typedef map< String, OverlayContainer * >::type | ChildContainerMap
typedef MapIterator < ChildContainerMap > | ChildContainerIterator
## Public Member Functions
| PanelOverlayElement (const String &name)
| Constructor.
virtual | ~PanelOverlayElement ()
virtual void | initialise (void)
| Initialise.
void | setTiling (Real x, Real y, ushort layer=0)
| Sets the number of times textures should repeat.
Real | getTileX (ushort layer=0) const
Real | getTileY (ushort layer=0) const
| Gets the number of times the texture should repeat vertically.
void | setUV (Real u1, Real v1, Real u2, Real v2)
| Sets the texture coordinates for the panel.
void | getUV (Real &u1, Real &v1, Real &u2, Real &v2) const
| Get the uv coordinates for the panel.
void | setTransparent (bool isTransparent)
| Sets whether this panel is transparent (used only as a grouping level), or if it is actually rendered.
bool | isTransparent (void) const
| Returns whether this panel is transparent.
virtual const String & | getTypeName (void) const
| See OverlayElement.
void | getRenderOperation (RenderOperation &op)
| See Renderable.
void | setMaterialName (const String &matName)
| Overridden from OverlayElement.
void | _updateRenderQueue (RenderQueue *queue)
| Overridden from OverlayContainer.
virtual void | addChild (OverlayElement *elem)
| Adds another OverlayElement to this container.
virtual void | addChildImpl (OverlayElement *elem)
| Adds another OverlayElement to this container.
virtual void | addChildImpl (OverlayContainer *cont)
| Add a nested container to this container.
virtual void | removeChild (const String &name)
| Removes a named element from this container.
virtual OverlayElement * | getChild (const String &name)
| Gets the named child of this container.
void | _addChild (OverlayElement *elem)
void | _removeChild (OverlayElement *elem)
void | _removeChild (const String &name)
virtual ChildIterator | getChildIterator (void)
| Gets an object for iterating over all the children of this object.
virtual ChildContainerIterator | getChildContainerIterator (void)
| Gets an iterator for just the container children of this object.
virtual void | _positionsOutOfDate (void)
| Tell the object and its children to recalculate.
virtual void | _update (void)
| Overridden from OverlayElement.
virtual ushort | _notifyZOrder (ushort newZOrder)
| Overridden from OverlayElement.
virtual void | _notifyViewport ()
| Overridden from OverlayElement.
virtual void | _notifyWorldTransforms (const Matrix4 &xform)
| Overridden from OverlayElement.
virtual void | _notifyParent (OverlayContainer *parent, Overlay *overlay)
| Overridden from OverlayElement.
bool | isContainer () const
| Overridden from OverlayElement.
virtual bool | isChildrenProcessEvents () const
| Should this container pass events to their children.
virtual void | setChildrenProcessEvents (bool val)
| Should this container pass events to their children.
virtual OverlayElement * | findElementAt (Real x, Real y)
| This returns a OverlayElement at position x,y.
void | copyFromTemplate (OverlayElement *templateOverlay)
virtual OverlayElement * | clone (const String &instanceName)
const String & | getName (void) const
| Gets the name of this overlay.
virtual void | show (void)
| Shows this element if it was hidden.
virtual void | hide (void)
| Hides this element if it was visible.
bool | isVisible (void) const
| Returns whether or not the element is visible.
bool | isEnabled () const
virtual void | setEnabled (bool b)
void | setDimensions (Real width, Real height)
| Sets the dimensions of this element in relation to the screen (1.0 = screen width/height).
void | setPosition (Real left, Real top)
| Sets the position of the top-left corner of the element, relative to the screen size (1.0 = screen width / height).
void | setWidth (Real width)
| Sets the width of this element in relation to the screen (where 1.0 = screen width).
Real | getWidth (void) const
| Gets the width of this element in relation to the screen (where 1.0 = screen width).
void | setHeight (Real height)
| Sets the height of this element in relation to the screen (where 1.0 = screen height).
Real | getHeight (void) const
| Gets the height of this element in relation to the screen (where 1.0 = screen height).
void | setLeft (Real left)
| Sets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right).
Real | getLeft (void) const
| Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right).
void | setTop (Real Top)
| Sets the top of this element in relation to the screen (where 0 = top, 1.0 = bottom).
Real | getTop (void) const
| Gets the top of this element in relation to the screen (where 0 = top, 1.0 = bottom).
Real | _getLeft (void) const
| Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right).
Real | _getTop (void) const
| Gets the top of this element in relation to the screen (where 0 = far left, 1.0 = far right).
Real | _getWidth (void) const
| Gets the width of this element in relation to the screen (where 1.0 = screen width).
Real | _getHeight (void) const
| Gets the height of this element in relation to the screen (where 1.0 = screen height).
void | _setLeft (Real left)
| Sets the left of this element in relation to the screen (where 1.0 = screen width).
void | _setTop (Real top)
| Sets the top of this element in relation to the screen (where 1.0 = screen width).
void | _setWidth (Real width)
| Sets the width of this element in relation to the screen (where 1.0 = screen width).
void | _setHeight (Real height)
| Sets the height of this element in relation to the screen (where 1.0 = screen width).
void | _setPosition (Real left, Real top)
| Sets the left and top of this element in relation to the screen (where 1.0 = screen width).
void | _setDimensions (Real width, Real height)
| Sets the width and height of this element in relation to the screen (where 1.0 = screen width).
virtual const String & | getMaterialName (void) const
| Gets the name of the material this element uses.
const MaterialPtr & | getMaterial (void) const
| See Renderable.
virtual const MaterialPtr & | getMaterial (void) const =0
| Retrieves a weak reference to the material this renderable object uses.
void | getWorldTransforms (Matrix4 *xform) const
| See Renderable.
virtual void | getWorldTransforms (Matrix4 *xform) const =0
| Gets the world transform matrix / matrices for this renderable object.
virtual void | _updateFromParent (void)
| Updates this elements transform based on it's parent.
virtual Real | _getDerivedLeft (void)
| Gets the 'left' position as derived from own left and that of parents.
virtual Real | _getDerivedTop (void)
| Gets the 'top' position as derived from own left and that of parents.
virtual Real | _getRelativeWidth (void)
| Gets the 'width' as derived from own width and metrics mode.
virtual Real | _getRelativeHeight (void)
| Gets the 'height' as derived from own height and metrics mode.
virtual void | _getClippingRegion (Rectangle &clippingRegion)
| Gets the clipping region of the element.
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false)
virtual void | setCaption (const DisplayString &text)
| Sets the caption on elements that support it.
virtual const DisplayString & | getCaption (void) const
| Gets the caption for this element.
virtual void | setColour (const ColourValue &col)
| Sets the colour on elements that support it.
virtual const ColourValue & | getColour (void) const
| Gets the colour for this element.
virtual void | setMetricsMode (GuiMetricsMode gmm)
| Tells this element how to interpret the position and dimension values it is given.
virtual GuiMetricsMode | getMetricsMode (void) const
| Retrieves the current settings of how the element metrics are interpreted.
virtual void | setHorizontalAlignment (GuiHorizontalAlignment gha)
| Sets the horizontal origin for this element.
virtual GuiHorizontalAlignment | getHorizontalAlignment (void) const
| Gets the horizontal alignment for this element.
virtual void | setVerticalAlignment (GuiVerticalAlignment gva)
| Sets the vertical origin for this element.
virtual GuiVerticalAlignment | getVerticalAlignment (void) const
| Gets the vertical alignment for this element.
virtual bool | contains (Real x, Real y) const
| Returns true if xy is within the constraints of the component.
virtual bool | isKeyEnabled () const
virtual bool | isCloneable () const
virtual void | setCloneable (bool c)
OverlayContainer * | getParent ()
| Returns the parent container.
void | _setParent (OverlayContainer *parent)
ushort | getZOrder () const
| Returns the zOrder of the element.
Real | getSquaredViewDepth (const Camera *cam) const
| Overridden from Renderable.
virtual Real | getSquaredViewDepth (const Camera *cam) const =0
| Returns the camera-relative squared depth of this renderable.
const LightList & | getLights (void) const
virtual const LightList & | getLights (void) const =0
| Gets a list of lights, ordered relative to how close they are to this renderable.
const OverlayElement * | getSourceTemplate () const
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
virtual void | getRenderOperation (RenderOperation &op)=0
| Gets the render operation required to send this object to the frame buffer.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual unsigned short | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual void | setUserAny (const Any &anything)
virtual const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
virtual RenderSystemData * | getRenderSystemData () const
| Sets render system private data.
virtual void | setRenderSystemData (RenderSystemData *val) const
| gets render system private data
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
## Protected Types
typedef map< size_t, Vector4 > ::type | CustomParameterMap
## Protected Member Functions
virtual void | updatePositionGeometry (void)
| internal method for setting up geometry, called by OverlayElement::update
virtual void | updateTextureGeometry (void)
| Called to update the texture coords when layers change.
void | addBaseParameters (void)
| Method for setting up base parameters for this class.
bool | createParamDictionary (const String &className)
| Internal method for creating a parameter dictionary for the class, if it does not already exist.
## Protected Attributes
bool | mTransparent
Real | mTileX [OGRE_MAX_TEXTURE_LAYERS]
Real | mTileY [OGRE_MAX_TEXTURE_LAYERS]
size_t | mNumTexCoordsInBuffer
Real | mU1
Real | mV1
Real | mU2
Real | mV2
RenderOperation | mRenderOp
ChildMap | mChildren
ChildContainerMap | mChildContainers
bool | mChildrenProcessEvents
String | mName
bool | mVisible
bool | mCloneable
Real | mLeft
Real | mTop
Real | mWidth
Real | mHeight
String | mMaterialName
MaterialPtr | mpMaterial
DisplayString | mCaption
ColourValue | mColour
Rectangle | mClippingRegion
GuiMetricsMode | mMetricsMode
GuiHorizontalAlignment | mHorzAlign
GuiVerticalAlignment | mVertAlign
Real | mPixelTop
Real | mPixelLeft
Real | mPixelWidth
Real | mPixelHeight
Real | mPixelScaleX
Real | mPixelScaleY
OverlayContainer * | mParent
Overlay * | mOverlay
Real | mDerivedLeft
Real | mDerivedTop
bool | mDerivedOutOfDate
bool | mGeomPositionsOutOfDate
| Flag indicating if the vertex positions need recalculating.
bool | mGeomUVsOutOfDate
| Flag indicating if the vertex uvs need recalculating.
ushort | mZOrder
Matrix4 | mXForm
bool | mEnabled
bool | mInitialised
OverlayElement * | mSourceTemplate
CustomParameterMap | mCustomParameters
bool | mPolygonModeOverrideable
bool | mUseIdentityProjection
bool | mUseIdentityView
UserObjectBindings | mUserObjectBindings
RenderSystemData * | mRenderSystemData
## Static Protected Attributes
static String | msTypeName
static CmdTiling | msCmdTiling
static CmdTransparent | msCmdTransparent
static CmdUVCoords | msCmdUVCoords
static OverlayElementCommands::CmdLeft | msLeftCmd
static OverlayElementCommands::CmdTop | msTopCmd
static OverlayElementCommands::CmdWidth | msWidthCmd
static OverlayElementCommands::CmdHeight | msHeightCmd
static OverlayElementCommands::CmdMaterial | msMaterialCmd
static OverlayElementCommands::CmdCaption | msCaptionCmd
static OverlayElementCommands::CmdMetricsMode | msMetricsModeCmd
static OverlayElementCommands::CmdHorizontalAlign | msHorizontalAlignCmd
static OverlayElementCommands::CmdVerticalAlign | msVerticalAlignCmd
static OverlayElementCommands::CmdVisible | msVisibleCmd

## Detailed Description

OverlayElement representing a flat, single-material (or transparent) panel which can contain other elements.

Remarks:
  This class subclasses OverlayContainer because it can contain other elements. Like other containers, if hidden it's contents are also hidden, if moved it's contents also move etc. The panel itself is a 2D rectangle which is either completely transparent, or is rendered with a single material. The texture(s) on the panel can be tiled depending on your requirements.

  This component is suitable for backgrounds and grouping other elements. Note that because it has a single repeating material it cannot have a discrete border (unless the texture has one and the texture is tiled only once). For a bordered panel, see it's subclass BorderPanelOverlayElement.

  Note that the material can have all the usual effects applied to it like multiple texture layers, scrolling / animated textures etc. For multiple texture layers, you have to set the tiling level for each layer.

Definition at line 58 of file OgrePanelOverlayElement.h.

## Member Typedef Documentation

typedef MapIterator<ChildContainerMap> Ogre::OverlayContainer::ChildContainerIterator`[inherited]`

Definition at line 62 of file OgreOverlayContainer.h.

typedef map<String, OverlayContainer*>::type Ogre::OverlayContainer::ChildContainerMap`[inherited]`

Definition at line 61 of file OgreOverlayContainer.h.

typedef MapIterator<ChildMap> Ogre::OverlayContainer::ChildIterator`[inherited]`

Definition at line 60 of file OgreOverlayContainer.h.

typedef map<String, OverlayElement*>::type Ogre::OverlayContainer::ChildMap`[inherited]`

Definition at line 59 of file OgreOverlayContainer.h.

typedef map<size_t, Vector4>::type Ogre::Renderable::CustomParameterMap`[protected, inherited]`

Definition at line 395 of file OgreRenderable.h.

## Constructor & Destructor Documentation

Ogre::PanelOverlayElement::PanelOverlayElement | ( | const String & | name | ) |

Constructor.

virtual Ogre::PanelOverlayElement::~PanelOverlayElement | ( |  | ) | `[virtual]`

## Member Function Documentation

void Ogre::OverlayContainer::_addChild | ( | OverlayElement * | elem | ) | `[inherited]`

virtual void Ogre::OverlayElement::_getClippingRegion | ( | Rectangle & | clippingRegion | ) | `[virtual, inherited]`

Gets the clipping region of the element.

virtual Real Ogre::OverlayElement::_getDerivedLeft | ( | void |  | ) | `[virtual, inherited]`

Gets the 'left' position as derived from own left and that of parents.

virtual Real Ogre::OverlayElement::_getDerivedTop | ( | void |  | ) | `[virtual, inherited]`

Gets the 'top' position as derived from own left and that of parents.

Real Ogre::OverlayElement::_getHeight | ( | void |  | ) | const`[inherited]`

Gets the height of this element in relation to the screen (where 1.0 = screen height).

Definition at line 263 of file OgreOverlayElement.h.

Real Ogre::OverlayElement::_getLeft | ( | void |  | ) | const`[inherited]`

Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right).

Definition at line 257 of file OgreOverlayElement.h.

virtual Real Ogre::OverlayElement::_getRelativeHeight | ( | void |  | ) | `[virtual, inherited]`

Gets the 'height' as derived from own height and metrics mode.

virtual Real Ogre::OverlayElement::_getRelativeWidth | ( | void |  | ) | `[virtual, inherited]`

Gets the 'width' as derived from own width and metrics mode.

Real Ogre::OverlayElement::_getTop | ( | void |  | ) | const`[inherited]`

Gets the top of this element in relation to the screen (where 0 = far left, 1.0 = far right).

Definition at line 259 of file OgreOverlayElement.h.

Real Ogre::OverlayElement::_getWidth | ( | void |  | ) | const`[inherited]`

Gets the width of this element in relation to the screen (where 1.0 = screen width).

Definition at line 261 of file OgreOverlayElement.h.

virtual void Ogre::OverlayContainer::_notifyParent | ( | OverlayContainer * | parent,
|  | Overlay * | overlay |
| ) |  |  | `[virtual, inherited]`

Overridden from OverlayElement.

Reimplemented from Ogre::OverlayElement.

virtual void Ogre::OverlayContainer::_notifyViewport | ( |  | ) | `[virtual, inherited]`

Overridden from OverlayElement.

Reimplemented from Ogre::OverlayElement.

virtual void Ogre::OverlayContainer::_notifyWorldTransforms | ( | const Matrix4 & | xform | ) | `[virtual, inherited]`

Overridden from OverlayElement.

Reimplemented from Ogre::OverlayElement.

virtual ushort Ogre::OverlayContainer::_notifyZOrder | ( | ushort | newZOrder | ) | `[virtual, inherited]`

Overridden from OverlayElement.

Reimplemented from Ogre::OverlayElement.

virtual void Ogre::OverlayContainer::_positionsOutOfDate | ( | void |  | ) | `[virtual, inherited]`

Tell the object and its children to recalculate.

Reimplemented from Ogre::OverlayElement.

void Ogre::OverlayContainer::_removeChild | ( | OverlayElement * | elem | ) | `[inherited]`

Definition at line 91 of file OgreOverlayContainer.h.

References Ogre::OverlayContainer::_removeChild(), and Ogre::OverlayElement::getName().

Referenced by Ogre::OverlayContainer::_removeChild().

void Ogre::OverlayContainer::_removeChild | ( | const String & | name | ) | `[inherited]`

void Ogre::OverlayElement::_setDimensions | ( | Real | width,
|  | Real | height |
| ) |  |  | `[inherited]`

Sets the width and height of this element in relation to the screen (where 1.0 = screen width).

void Ogre::OverlayElement::_setHeight | ( | Real | height | ) | `[inherited]`

Sets the height of this element in relation to the screen (where 1.0 = screen width).

void Ogre::OverlayElement::_setLeft | ( | Real | left | ) | `[inherited]`

Sets the left of this element in relation to the screen (where 1.0 = screen width).

void Ogre::OverlayElement::_setParent | ( | OverlayContainer * | parent | ) | `[inherited]`

Definition at line 461 of file OgreOverlayElement.h.

void Ogre::OverlayElement::_setPosition | ( | Real | left,
|  | Real | top |
| ) |  |  | `[inherited]`

Sets the left and top of this element in relation to the screen (where 1.0 = screen width).

void Ogre::OverlayElement::_setTop | ( | Real | top | ) | `[inherited]`

Sets the top of this element in relation to the screen (where 1.0 = screen width).

void Ogre::OverlayElement::_setWidth | ( | Real | width | ) | `[inherited]`

Sets the width of this element in relation to the screen (where 1.0 = screen width).

virtual void Ogre::OverlayContainer::_update | ( | void |  | ) | `[virtual, inherited]`

Overridden from OverlayElement.

Reimplemented from Ogre::OverlayElement.

Reimplemented in Ogre::BorderPanelOverlayElement.

virtual void Ogre::Renderable::_updateCustomGpuParameter | ( | const GpuProgramParameters::AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params |
| ) |  |  | const`[virtual, inherited]`

Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.

Remarks:
  This method allows a Renderable to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_CUSTOM, and to allow there to be more than one of these per Renderable, the 'data' field on the auto parameter will identify which parameter is being updated. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object, using the details provided in the incoming auto constant setting to identify the index at which to set the parameter.

  You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case.

Parameters:

  | constantEntry | The auto constant entry referring to the parameter being updated
  | params | The parameters object which this method should call to set the updated parameters.

Definition at line 288 of file OgreRenderable.h.

References Ogre::GpuProgramParameters::_writeRawConstant(), Ogre::GpuProgramParameters::AutoConstantEntry::data, Ogre::GpuProgramParameters::AutoConstantEntry::elementCount, and Ogre::GpuProgramParameters::AutoConstantEntry::physicalIndex.

virtual void Ogre::OverlayElement::_updateFromParent | ( | void |  | ) | `[virtual, inherited]`

Updates this elements transform based on it's parent.

void Ogre::PanelOverlayElement::_updateRenderQueue | ( | RenderQueue * | queue | ) | `[virtual]`

Overridden from OverlayContainer.

Reimplemented from Ogre::OverlayContainer.

Reimplemented in Ogre::BorderPanelOverlayElement.

void Ogre::PanelOverlayElement::addBaseParameters | ( | void |  | ) | `[protected, virtual]`

Method for setting up base parameters for this class.

Reimplemented from Ogre::OverlayElement.

Reimplemented in Ogre::BorderPanelOverlayElement.

virtual void Ogre::OverlayContainer::addChild | ( | OverlayElement * | elem | ) | `[virtual, inherited]`

Adds another OverlayElement to this container.

virtual void Ogre::OverlayContainer::addChildImpl | ( | OverlayElement * | elem | ) | `[virtual, inherited]`

Adds another OverlayElement to this container.

virtual void Ogre::OverlayContainer::addChildImpl | ( | OverlayContainer * | cont | ) | `[virtual, inherited]`

Add a nested container to this container.

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) | `[static, inherited]`

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

virtual OverlayElement* Ogre::OverlayContainer::clone | ( | const String & | instanceName | ) | `[virtual, inherited]`

Reimplemented from Ogre::OverlayElement.

virtual bool Ogre::OverlayElement::contains | ( | Real | x,
|  | Real | y |
| ) |  |  | const`[virtual, inherited]`

Returns true if xy is within the constraints of the component.

void Ogre::OverlayContainer::copyFromTemplate | ( | OverlayElement * | templateOverlay | ) | `[virtual, inherited]`

Reimplemented from Ogre::OverlayElement.

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const`[virtual, inherited]`

Method for copying this object's parameters to another object.

Remarks:
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters:

  | dest | Pointer to object to have it's parameters set the same as this object.

Definition at line 301 of file OgreStringInterface.h.

References Ogre::ParamDictionary::mParamDefs, and Ogre::StringInterface::setParameter().

bool Ogre::StringInterface::createParamDictionary | ( | const String & | className | ) | `[protected, inherited]`

Internal method for creating a parameter dictionary for the class, if it does not already exist.

Remarks:
  This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance).

Parameters:

  | className | the name of the class using the dictionary

Returns:
  true if a new dictionary was created, false if it was already there

Definition at line 184 of file OgreStringInterface.h.

References OGRE_LOCK_MUTEX.

virtual OverlayElement* Ogre::OverlayContainer::findElementAt | ( | Real | x,
|  | Real | y |
| ) |  |  | `[virtual, inherited]`

This returns a OverlayElement at position x,y.

Reimplemented from Ogre::OverlayElement.

virtual const DisplayString& Ogre::OverlayElement::getCaption | ( | void |  | ) | const`[virtual, inherited]`

Gets the caption for this element.

virtual bool Ogre::Renderable::getCastsShadows | ( | void |  | ) | const`[virtual, inherited]`

Method which reports whether this renderable would normally cast a shadow.

Remarks:
  Subclasses should override this if they could have been used to generate a shadow.

Reimplemented in Ogre::InstancedGeometry::GeometryBucket.

Definition at line 223 of file OgreRenderable.h.

virtual OverlayElement* Ogre::OverlayContainer::getChild | ( | const String & | name | ) | `[virtual, inherited]`

Gets the named child of this container.

virtual ChildContainerIterator Ogre::OverlayContainer::getChildContainerIterator | ( | void |  | ) | `[virtual, inherited]`

Gets an iterator for just the container children of this object.

Remarks:
  Good for cascading updates without having to use RTTI

virtual ChildIterator Ogre::OverlayContainer::getChildIterator | ( | void |  | ) | `[virtual, inherited]`

Gets an object for iterating over all the children of this object.

virtual const ColourValue& Ogre::OverlayElement::getColour | ( | void |  | ) | const`[virtual, inherited]`

Gets the colour for this element.

Reimplemented in Ogre::TextAreaOverlayElement.

const Vector4& Ogre::Renderable::getCustomParameter | ( | size_t | index | ) | const`[inherited]`

Gets the custom value associated with this Renderable at the given index.

Parameters:

  | @see | setCustomParaemter for full details.

Definition at line 249 of file OgreRenderable.h.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

Real Ogre::OverlayElement::getHeight | ( | void |  | ) | const`[inherited]`

Gets the height of this element in relation to the screen (where 1.0 = screen height).

virtual GuiHorizontalAlignment Ogre::OverlayElement::getHorizontalAlignment | ( | void |  | ) | const`[virtual, inherited]`

Gets the horizontal alignment for this element.

Real Ogre::OverlayElement::getLeft | ( | void |  | ) | const`[inherited]`

Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right).

const LightList& Ogre::OverlayElement::getLights | ( | void |  | ) | const`[inherited]`

Gets a list of lights, ordered relative to how close they are to this renderable.

Remarks:
  Directional lights, which have no position, will always be first on this list.

Definition at line 477 of file OgreOverlayElement.h.

virtual const LightList& Ogre::Renderable::getLights | ( | void |  | ) | const`[pure virtual, inherited]`

Gets a list of lights, ordered relative to how close they are to this renderable.

Remarks:
  Directional lights, which have no position, will always be first on this list.

Implemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::Frustum, Ogre::InstancedGeometry::GeometryBucket, and Ogre::SimpleRenderable.

const MaterialPtr& Ogre::OverlayElement::getMaterial | ( | void |  | ) | const`[inherited]`

See Renderable.

Reimplemented in Ogre::TextAreaOverlayElement.

virtual const MaterialPtr& Ogre::Renderable::getMaterial | ( | void |  | ) | const`[pure virtual, inherited]`

Retrieves a weak reference to the material this renderable object uses.

Remarks:
  Note that the Renderable also has the option to override the getTechnique method to specify a particular Technique to use instead of the best one available.

Implemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::Frustum, Ogre::InstancedGeometry::GeometryBucket, and Ogre::SimpleRenderable.

virtual const String& Ogre::OverlayElement::getMaterialName | ( | void |  | ) | const`[virtual, inherited]`

Gets the name of the material this element uses.

virtual GuiMetricsMode Ogre::OverlayElement::getMetricsMode | ( | void |  | ) | const`[virtual, inherited]`

Retrieves the current settings of how the element metrics are interpreted.

const String& Ogre::OverlayElement::getName | ( | void |  | ) | const`[inherited]`

Gets the name of this overlay.

Referenced by Ogre::OverlayContainer::_removeChild().

virtual unsigned short Ogre::Renderable::getNumWorldTransforms | ( | void |  | ) | const`[virtual, inherited]`

Returns the number of world transform matrices this renderable requires.

Remarks:
  When a renderable uses vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity.

Reimplemented in Ogre::InstancedGeometry::GeometryBucket.

Definition at line 152 of file OgreRenderable.h.

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | `[inherited]`

Retrieves the parameter dictionary for this class.

Remarks:
  Only valid to call this after createParamDictionary.

Returns:
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

Definition at line 217 of file OgreStringInterface.h.

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const`[inherited]`

Definition at line 222 of file OgreStringInterface.h.

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const`[virtual, inherited]`

Generic parameter retrieval method.

Remarks:
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters:

  | name | The name of the parameter to get

Returns:
  String value of parameter, blank if not found

Definition at line 270 of file OgreStringInterface.h.

References Ogre::ParamCommand::doGet(), and Ogre::ParamDictionary::getParamCommand().

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const`[inherited]`

Retrieves a list of parameters valid for this object.

Returns:
  A reference to a static list of ParameterDef objects.

OverlayContainer* Ogre::OverlayElement::getParent | ( |  | ) | `[inherited]`

Returns the parent container.

virtual bool Ogre::Renderable::getPolygonModeOverrideable | ( | void |  | ) | const`[virtual, inherited]`

Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Definition at line 313 of file OgreRenderable.h.

virtual void Ogre::Renderable::getRenderOperation | ( | RenderOperation & | op | ) | `[pure virtual, inherited]`

Gets the render operation required to send this object to the frame buffer.

Implemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::Frustum, and Ogre::SimpleRenderable.

void Ogre::PanelOverlayElement::getRenderOperation | ( | RenderOperation & | op | ) |

See Renderable.

virtual RenderSystemData* Ogre::Renderable::getRenderSystemData | ( |  | ) | const`[virtual, inherited]`

Sets render system private data.

Remarks:
  This should only be used by a render system

Definition at line 380 of file OgreRenderable.h.

const OverlayElement* Ogre::OverlayElement::getSourceTemplate | ( |  | ) | const`[inherited]`

Definition at line 488 of file OgreOverlayElement.h.

Real Ogre::OverlayElement::getSquaredViewDepth | ( | const Camera * | cam | ) | const`[inherited]`

Overridden from Renderable.

Definition at line 470 of file OgreOverlayElement.h.

virtual Real Ogre::Renderable::getSquaredViewDepth | ( | const Camera * | cam | ) | const`[pure virtual, inherited]`

Returns the camera-relative squared depth of this renderable.

Remarks:
  Used to sort transparent objects. Squared depth is used rather than actual depth to avoid having to perform a square root on the result.

Implemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::Frustum, Ogre::InstancedGeometry::GeometryBucket, Ogre::Rectangle2D, and Ogre::WireBoundingBox.

Referenced by Ogre::QueuedRenderableCollection::RadixSortFunctorDistance::operator()(), and Ogre::QueuedRenderableCollection::DepthSortDescendingLess::operator()().

virtual Technique* Ogre::Renderable::getTechnique | ( | void |  | ) | const`[virtual, inherited]`

Retrieves a pointer to the Material Technique this renderable object uses.

Remarks:
  This is to allow Renderables to use a chosen Technique if they wish, otherwise they will use the best Technique available for the Material they are using.

Reimplemented in Ogre::InstancedGeometry::GeometryBucket.

Definition at line 93 of file OgreRenderable.h.

Real Ogre::PanelOverlayElement::getTileX | ( | ushort | layer = `0` | ) | const

Real Ogre::PanelOverlayElement::getTileY | ( | ushort | layer = `0` | ) | const

Gets the number of times the texture should repeat vertically.

Parameters:

  | layer | The texture layer to specify (only needs to be altered if you're using a multi-texture layer material)

Real Ogre::OverlayElement::getTop | ( | void |  | ) | const`[inherited]`

Gets the top of this element in relation to the screen (where 0 = top, 1.0 = bottom).

virtual const String& Ogre::PanelOverlayElement::getTypeName | ( | void |  | ) | const`[virtual]`

See OverlayElement.

Implements Ogre::OverlayElement.

Reimplemented in Ogre::BorderPanelOverlayElement.

bool Ogre::Renderable::getUseIdentityProjection | ( | void |  | ) | const`[inherited]`

Returns whether or not to use an 'identity' projection.

Remarks:
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this.

See also:
  Renderable::setUseIdentityProjection

Definition at line 177 of file OgreRenderable.h.

bool Ogre::Renderable::getUseIdentityView | ( | void |  | ) | const`[inherited]`

Returns whether or not to use an 'identity' view.

Remarks:
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this.

See also:
  Renderable::setUseIdentityView

Definition at line 202 of file OgreRenderable.h.

virtual const Any& Ogre::Renderable::getUserAny | ( | void |  | ) | const`[virtual, inherited]`

Deprecated:
  use UserObjectBindings::getUserAny via getUserObjectBindings() instead.

Retrieves the custom user value associated with this object.

Definition at line 330 of file OgreRenderable.h.

const UserObjectBindings& Ogre::Renderable::getUserObjectBindings | ( |  | ) | const`[inherited]`

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also:
  UserObjectBindings::setUserAny.

Definition at line 342 of file OgreRenderable.h.

UserObjectBindings& Ogre::Renderable::getUserObjectBindings | ( |  | ) | `[inherited]`

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also:
  UserObjectBindings::setUserAny.

Definition at line 336 of file OgreRenderable.h.

void Ogre::PanelOverlayElement::getUV | ( | Real & | u1,
|  | Real & | v1,
|  | Real & | u2,
|  | Real & | v2 |
| ) |  |  | const

Get the uv coordinates for the panel.

virtual GuiVerticalAlignment Ogre::OverlayElement::getVerticalAlignment | ( | void |  | ) | const`[virtual, inherited]`

Gets the vertical alignment for this element.

Real Ogre::OverlayElement::getWidth | ( | void |  | ) | const`[inherited]`

Gets the width of this element in relation to the screen (where 1.0 = screen width).

void Ogre::OverlayElement::getWorldTransforms | ( | Matrix4 * | xform | ) | const`[inherited]`

See Renderable.

virtual void Ogre::Renderable::getWorldTransforms | ( | Matrix4 * | xform | ) | const`[pure virtual, inherited]`

Gets the world transform matrix / matrices for this renderable object.

Remarks:
  If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called.

  This method will populate xform with 1 matrix if it does not use vertex blending. If it does use vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms.

Note:
  Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here.

See also:
  Matrix4::isAffine.

Implemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::Frustum, Ogre::InstancedGeometry::GeometryBucket, Ogre::Rectangle2D, Ogre::SimpleRenderable, and Ogre::WireBoundingBox.

ushort Ogre::OverlayElement::getZOrder | ( |  | ) | const`[inherited]`

Returns the zOrder of the element.

Definition at line 466 of file OgreOverlayElement.h.

virtual void Ogre::OverlayElement::hide | ( | void |  | ) | `[virtual, inherited]`

Hides this element if it was visible.

virtual void Ogre::PanelOverlayElement::initialise | ( | void |  | ) | `[virtual]`

Initialise.

Reimplemented from Ogre::OverlayContainer.

Reimplemented in Ogre::BorderPanelOverlayElement.

virtual bool Ogre::OverlayContainer::isChildrenProcessEvents | ( |  | ) | const`[virtual, inherited]`

Should this container pass events to their children.

Definition at line 129 of file OgreOverlayContainer.h.

virtual bool Ogre::OverlayElement::isCloneable | ( |  | ) | const`[virtual, inherited]`

Definition at line 451 of file OgreOverlayElement.h.

bool Ogre::OverlayContainer::isContainer | ( |  | ) | const`[virtual, inherited]`

Overridden from OverlayElement.

Reimplemented from Ogre::OverlayElement.

Definition at line 125 of file OgreOverlayContainer.h.

bool Ogre::OverlayElement::isEnabled | ( |  | ) | const`[inherited]`

virtual bool Ogre::OverlayElement::isKeyEnabled | ( |  | ) | const`[virtual, inherited]`

Definition at line 448 of file OgreOverlayElement.h.

bool Ogre::PanelOverlayElement::isTransparent | ( | void |  | ) | const

Returns whether this panel is transparent.

bool Ogre::OverlayElement::isVisible | ( | void |  | ) | const`[inherited]`

Returns whether or not the element is visible.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

virtual void Ogre::Renderable::postRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys |
| ) |  |  | `[virtual, inherited]`

Called immediately after the Renderable has been rendered.

Definition at line 127 of file OgreRenderable.h.

virtual bool Ogre::Renderable::preRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys |
| ) |  |  | `[virtual, inherited]`

Called just prior to the Renderable being rendered.

Remarks:
  OGRE is a queued renderer, so the actual render commands are executed at a later time than the point at which an object is discovered to be visible. This allows ordering & grouping of renders without the discovery process having to be aware of it. It also means OGRE uses declarative render information rather than immediate mode rendering - this is very useful in that certain effects and processes can automatically be applied to a wide range of scenes, but the downside is that special cases are more difficult to handle, because there is not the declared state to cope with it.

  This method allows a Renderable to do something special at the actual point of rendering if it wishes to. When this method is called, all the material render state as declared by this Renderable has already been set, all that is left to do is to bind the buffers and perform the render. The Renderable may modify render state itself if it wants to (and restore it in the postRender call) before the automated render happens, or by returning 'false' from this method can actually suppress the automatic render and perform one of its own.

Returns:
  true if the automatic render should proceed, false to skip it on the assumption that the Renderable has done it manually.

Definition at line 122 of file OgreRenderable.h.

virtual void Ogre::OverlayContainer::removeChild | ( | const String & | name | ) | `[virtual, inherited]`

Removes a named element from this container.

virtual void Ogre::OverlayElement::setCaption | ( | const DisplayString & | text | ) | `[virtual, inherited]`

Sets the caption on elements that support it.

Remarks:
  This property doesn't do something on all elements, just those that support it. However, being a common requirement it is in the top-level interface to avoid having to set it via the StringInterface all the time.

Reimplemented in Ogre::TextAreaOverlayElement.

virtual void Ogre::OverlayContainer::setChildrenProcessEvents | ( | bool | val | ) | `[virtual, inherited]`

Should this container pass events to their children.

Definition at line 133 of file OgreOverlayContainer.h.

virtual void Ogre::OverlayElement::setCloneable | ( | bool | c | ) | `[virtual, inherited]`

Definition at line 454 of file OgreOverlayElement.h.

virtual void Ogre::OverlayElement::setColour | ( | const ColourValue & | col | ) | `[virtual, inherited]`

Sets the colour on elements that support it.

Remarks:
  This property doesn't do something on all elements, just those that support it. However, being a common requirement it is in the top-level interface to avoid having to set it via the StringInterface all the time.

Reimplemented in Ogre::TextAreaOverlayElement.

void Ogre::Renderable::setCustomParameter | ( | size_t | index,
|  | const Vector4 & | value |
| ) |  |  | `[inherited]`

Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.

Remarks:
  Calling this method simply associates a numeric index with a 4-dimensional value for this specific Renderable. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter.

Parameters:

  | index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_CUSTOM entry, if that is used.
  | value | The value to associate.

Definition at line 240 of file OgreRenderable.h.

void Ogre::OverlayElement::setDimensions | ( | Real | width,
|  | Real | height |
| ) |  |  | `[inherited]`

Sets the dimensions of this element in relation to the screen (1.0 = screen width/height).

virtual void Ogre::OverlayElement::setEnabled | ( | bool | b | ) | `[virtual, inherited]`

void Ogre::OverlayElement::setHeight | ( | Real | height | ) | `[inherited]`

Sets the height of this element in relation to the screen (where 1.0 = screen height).

virtual void Ogre::OverlayElement::setHorizontalAlignment | ( | GuiHorizontalAlignment | gha | ) | `[virtual, inherited]`

Sets the horizontal origin for this element.

Remarks:
  By default, the horizontal origin for a OverlayElement is the left edge of the parent container (or the screen if this is a root element). You can alter this by calling this method, which is especially useful when you want to use pixel-based metrics (see setMetricsMode) since in this mode you can't use relative positioning.

  For example, if you were using GMM_PIXELS metrics mode, and you wanted to place a 30x30 pixel crosshair in the center of the screen, you would use GHA_CENTER with a 'left' property of -15.

  Note that neither GHA_CENTER or GHA_RIGHT alter the position of the element based on it's width, you have to alter the 'left' to a negative number to do that; all this does is establish the origin. This is because this way you can align multiple things in the center and right with different 'left' offsets for maximum flexibility.

void Ogre::OverlayElement::setLeft | ( | Real | left | ) | `[inherited]`

Sets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right).

void Ogre::PanelOverlayElement::setMaterialName | ( | const String & | matName | ) | `[virtual]`

Overridden from OverlayElement.

Reimplemented from Ogre::OverlayElement.

virtual void Ogre::OverlayElement::setMetricsMode | ( | GuiMetricsMode | gmm | ) | `[virtual, inherited]`

Tells this element how to interpret the position and dimension values it is given.

Remarks:
  By default, OverlayElements are positioned and sized according to relative dimensions of the screen. This is to ensure portability between different resolutions when you want things to be positioned and sized the same way across all resolutions. However, sometimes you want things to be sized according to fixed pixels. In order to do this, you can call this method with the parameter GMM_PIXELS. Note that if you then want to place your element relative to the center, right or bottom of it's parent, you will need to use the setHorizontalAlignment and setVerticalAlignment methods.

Reimplemented in Ogre::BorderPanelOverlayElement, and Ogre::TextAreaOverlayElement.

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value |
| ) |  |  | `[virtual, inherited]`

Generic parameter setting method.

Remarks:
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | name | The name of the parameter to set
  | value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns:
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) | `[virtual, inherited]`

Generic multiple parameter setting method.

Remarks:
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | paramList | Name/value pair list

virtual void Ogre::Renderable::setPolygonModeOverrideable | ( | bool | override | ) | `[virtual, inherited]`

Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Parameters:

  | override | true means that a lower camera detail will override this renderables detail level, false means it won't.

Definition at line 305 of file OgreRenderable.h.

void Ogre::OverlayElement::setPosition | ( | Real | left,
|  | Real | top |
| ) |  |  | `[inherited]`

Sets the position of the top-left corner of the element, relative to the screen size (1.0 = screen width / height).

virtual void Ogre::Renderable::setRenderSystemData | ( | RenderSystemData * | val | ) | const`[virtual, inherited]`

gets render system private data

Remarks:
  This should only be used by a render system

Definition at line 388 of file OgreRenderable.h.

void Ogre::PanelOverlayElement::setTiling | ( | Real | x,
|  | Real | y,
|  | ushort | layer = `0` |
| ) |  |  |

Sets the number of times textures should repeat.

Parameters:

  | x | The number of times the texture should repeat horizontally
  | y | The number of times the texture should repeat vertically
  | layer | The texture layer to specify (only needs to be altered if you're using a multi-texture layer material)

void Ogre::OverlayElement::setTop | ( | Real | Top | ) | `[inherited]`

Sets the top of this element in relation to the screen (where 0 = top, 1.0 = bottom).

void Ogre::PanelOverlayElement::setTransparent | ( | bool | isTransparent | ) |

Sets whether this panel is transparent (used only as a grouping level), or if it is actually rendered.

void Ogre::Renderable::setUseIdentityProjection | ( | bool | useIdentityProjection | ) | `[inherited]`

Sets whether or not to use an 'identity' projection.

Remarks:
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also:
  Renderable::getUseIdentityProjection

Definition at line 163 of file OgreRenderable.h.

void Ogre::Renderable::setUseIdentityView | ( | bool | useIdentityView | ) | `[inherited]`

Sets whether or not to use an 'identity' view.

Remarks:
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also:
  Renderable::getUseIdentityView

Definition at line 188 of file OgreRenderable.h.

virtual void Ogre::Renderable::setUserAny | ( | const Any & | anything | ) | `[virtual, inherited]`

Deprecated:
  use UserObjectBindings::setUserAny via getUserObjectBindings() instead.

Sets any kind of user value on this object.

Remarks:
  This method allows you to associate any user value you like with this Renderable. This can be a pointer back to one of your own classes for instance.

Definition at line 325 of file OgreRenderable.h.

void Ogre::PanelOverlayElement::setUV | ( | Real | u1,
|  | Real | v1,
|  | Real | u2,
|  | Real | v2 |
| ) |  |  |

Sets the texture coordinates for the panel.

virtual void Ogre::OverlayElement::setVerticalAlignment | ( | GuiVerticalAlignment | gva | ) | `[virtual, inherited]`

Sets the vertical origin for this element.

Remarks:
  By default, the vertical origin for a OverlayElement is the top edge of the parent container (or the screen if this is a root element). You can alter this by calling this method, which is especially useful when you want to use pixel-based metrics (see setMetricsMode) since in this mode you can't use relative positioning.

  For example, if you were using GMM_PIXELS metrics mode, and you wanted to place a 30x30 pixel crosshair in the center of the screen, you would use GHA_CENTER with a 'top' property of -15.

  Note that neither GVA_CENTER or GVA_BOTTOM alter the position of the element based on it's height, you have to alter the 'top' to a negative number to do that; all this does is establish the origin. This is because this way you can align multiple things in the center and bottom with different 'top' offsets for maximum flexibility.

void Ogre::OverlayElement::setWidth | ( | Real | width | ) | `[inherited]`

Sets the width of this element in relation to the screen (where 1.0 = screen width).

virtual void Ogre::OverlayElement::show | ( | void |  | ) | `[virtual, inherited]`

Shows this element if it was hidden.

virtual void Ogre::PanelOverlayElement::updatePositionGeometry | ( | void |  | ) | `[protected, virtual]`

internal method for setting up geometry, called by OverlayElement::update

Implements Ogre::OverlayElement.

Reimplemented in Ogre::BorderPanelOverlayElement.

virtual void Ogre::PanelOverlayElement::updateTextureGeometry | ( | void |  | ) | `[protected, virtual]`

Called to update the texture coords when layers change.

Implements Ogre::OverlayElement.

Reimplemented in Ogre::BorderPanelOverlayElement.

void Ogre::OverlayElement::visitRenderables | ( | Renderable::Visitor * | visitor,
|  | bool | debugRenderables = `false` |
| ) |  |  | `[inherited]`

Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.

Parameters:

  | visitor | Pointer to a class implementing the Renderable::Visitor interface which will be called back for each Renderable which will be queued. Bear in mind that the state of the Renderable instances may not be finalised depending on when you call this.
  | debugRenderables | If false, only regular renderables will be visited (those for normal display). If true, debug renderables will be included too.

Reimplemented in Ogre::BorderPanelOverlayElement.

## Member Data Documentation

DisplayString Ogre::OverlayElement::mCaption`[protected, inherited]`

Definition at line 136 of file OgreOverlayElement.h.

ChildContainerMap Ogre::OverlayContainer::mChildContainers`[protected, inherited]`

Definition at line 67 of file OgreOverlayContainer.h.

ChildMap Ogre::OverlayContainer::mChildren`[protected, inherited]`

Definition at line 65 of file OgreOverlayContainer.h.

bool Ogre::OverlayContainer::mChildrenProcessEvents`[protected, inherited]`

Definition at line 69 of file OgreOverlayContainer.h.

Rectangle Ogre::OverlayElement::mClippingRegion`[protected, inherited]`

Definition at line 138 of file OgreOverlayElement.h.

bool Ogre::OverlayElement::mCloneable`[protected, inherited]`

Definition at line 129 of file OgreOverlayElement.h.

ColourValue Ogre::OverlayElement::mColour`[protected, inherited]`

Definition at line 137 of file OgreOverlayElement.h.

CustomParameterMap Ogre::Renderable::mCustomParameters`[protected, inherited]`

Definition at line 396 of file OgreRenderable.h.

Real Ogre::OverlayElement::mDerivedLeft`[protected, inherited]`

Definition at line 158 of file OgreOverlayElement.h.

bool Ogre::OverlayElement::mDerivedOutOfDate`[protected, inherited]`

Definition at line 160 of file OgreOverlayElement.h.

Real Ogre::OverlayElement::mDerivedTop`[protected, inherited]`

Definition at line 159 of file OgreOverlayElement.h.

bool Ogre::OverlayElement::mEnabled`[protected, inherited]`

Definition at line 175 of file OgreOverlayElement.h.

bool Ogre::OverlayElement::mGeomPositionsOutOfDate`[protected, inherited]`

Flag indicating if the vertex positions need recalculating.

Definition at line 163 of file OgreOverlayElement.h.

bool Ogre::OverlayElement::mGeomUVsOutOfDate`[protected, inherited]`

Flag indicating if the vertex uvs need recalculating.

Definition at line 165 of file OgreOverlayElement.h.

Real Ogre::OverlayElement::mHeight`[protected, inherited]`

Definition at line 133 of file OgreOverlayElement.h.

GuiHorizontalAlignment Ogre::OverlayElement::mHorzAlign`[protected, inherited]`

Definition at line 141 of file OgreOverlayElement.h.

bool Ogre::OverlayElement::mInitialised`[protected, inherited]`

Definition at line 178 of file OgreOverlayElement.h.

Real Ogre::OverlayElement::mLeft`[protected, inherited]`

Definition at line 130 of file OgreOverlayElement.h.

String Ogre::OverlayElement::mMaterialName`[protected, inherited]`

Definition at line 134 of file OgreOverlayElement.h.

GuiMetricsMode Ogre::OverlayElement::mMetricsMode`[protected, inherited]`

Definition at line 140 of file OgreOverlayElement.h.

String Ogre::OverlayElement::mName`[protected, inherited]`

Definition at line 127 of file OgreOverlayElement.h.

size_t Ogre::PanelOverlayElement::mNumTexCoordsInBuffer`[protected]`

Definition at line 134 of file OgrePanelOverlayElement.h.

Overlay* Ogre::OverlayElement::mOverlay`[protected, inherited]`

Definition at line 155 of file OgreOverlayElement.h.

OverlayContainer* Ogre::OverlayElement::mParent`[protected, inherited]`

Definition at line 153 of file OgreOverlayElement.h.

Real Ogre::OverlayElement::mPixelHeight`[protected, inherited]`

Definition at line 148 of file OgreOverlayElement.h.

Real Ogre::OverlayElement::mPixelLeft`[protected, inherited]`

Definition at line 146 of file OgreOverlayElement.h.

Real Ogre::OverlayElement::mPixelScaleX`[protected, inherited]`

Definition at line 149 of file OgreOverlayElement.h.

Real Ogre::OverlayElement::mPixelScaleY`[protected, inherited]`

Definition at line 150 of file OgreOverlayElement.h.

Real Ogre::OverlayElement::mPixelTop`[protected, inherited]`

Definition at line 145 of file OgreOverlayElement.h.

Real Ogre::OverlayElement::mPixelWidth`[protected, inherited]`

Definition at line 147 of file OgreOverlayElement.h.

MaterialPtr Ogre::OverlayElement::mpMaterial`[protected, inherited]`

Definition at line 135 of file OgreOverlayElement.h.

bool Ogre::Renderable::mPolygonModeOverrideable`[protected, inherited]`

Definition at line 397 of file OgreRenderable.h.

RenderOperation Ogre::PanelOverlayElement::mRenderOp`[protected]`

Definition at line 137 of file OgrePanelOverlayElement.h.

RenderSystemData* Ogre::Renderable::mRenderSystemData`[mutable, protected, inherited]`

Definition at line 401 of file OgreRenderable.h.

OverlayElementCommands::CmdCaption Ogre::OverlayElement::msCaptionCmd`[static, protected, inherited]`

Definition at line 120 of file OgreOverlayElement.h.

CmdTiling Ogre::PanelOverlayElement::msCmdTiling`[static, protected]`

Definition at line 151 of file OgrePanelOverlayElement.h.

CmdTransparent Ogre::PanelOverlayElement::msCmdTransparent`[static, protected]`

Definition at line 152 of file OgrePanelOverlayElement.h.

CmdUVCoords Ogre::PanelOverlayElement::msCmdUVCoords`[static, protected]`

Definition at line 153 of file OgrePanelOverlayElement.h.

OverlayElementCommands::CmdHeight Ogre::OverlayElement::msHeightCmd`[static, protected, inherited]`

Definition at line 118 of file OgreOverlayElement.h.

OverlayElementCommands::CmdHorizontalAlign Ogre::OverlayElement::msHorizontalAlignCmd`[static, protected, inherited]`

Definition at line 122 of file OgreOverlayElement.h.

OverlayElementCommands::CmdLeft Ogre::OverlayElement::msLeftCmd`[static, protected, inherited]`

Definition at line 115 of file OgreOverlayElement.h.

OverlayElementCommands::CmdMaterial Ogre::OverlayElement::msMaterialCmd`[static, protected, inherited]`

Definition at line 119 of file OgreOverlayElement.h.

OverlayElementCommands::CmdMetricsMode Ogre::OverlayElement::msMetricsModeCmd`[static, protected, inherited]`

Definition at line 121 of file OgreOverlayElement.h.

OverlayElement* Ogre::OverlayElement::mSourceTemplate`[protected, inherited]`

Definition at line 181 of file OgreOverlayElement.h.

OverlayElementCommands::CmdTop Ogre::OverlayElement::msTopCmd`[static, protected, inherited]`

Definition at line 116 of file OgreOverlayElement.h.

String Ogre::PanelOverlayElement::msTypeName`[static, protected]`

Reimplemented in Ogre::BorderPanelOverlayElement.

Definition at line 148 of file OgrePanelOverlayElement.h.

OverlayElementCommands::CmdVerticalAlign Ogre::OverlayElement::msVerticalAlignCmd`[static, protected, inherited]`

Definition at line 123 of file OgreOverlayElement.h.

OverlayElementCommands::CmdVisible Ogre::OverlayElement::msVisibleCmd`[static, protected, inherited]`

Definition at line 124 of file OgreOverlayElement.h.

OverlayElementCommands::CmdWidth Ogre::OverlayElement::msWidthCmd`[static, protected, inherited]`

Definition at line 117 of file OgreOverlayElement.h.

Real Ogre::PanelOverlayElement::mTileX[OGRE_MAX_TEXTURE_LAYERS]`[protected]`

Definition at line 132 of file OgrePanelOverlayElement.h.

Real Ogre::PanelOverlayElement::mTileY[OGRE_MAX_TEXTURE_LAYERS]`[protected]`

Definition at line 133 of file OgrePanelOverlayElement.h.

Real Ogre::OverlayElement::mTop`[protected, inherited]`

Definition at line 131 of file OgreOverlayElement.h.

bool Ogre::PanelOverlayElement::mTransparent`[protected]`

Definition at line 130 of file OgrePanelOverlayElement.h.

Real Ogre::PanelOverlayElement::mU1`[protected]`

Definition at line 135 of file OgrePanelOverlayElement.h.

Real Ogre::PanelOverlayElement::mU2`[protected]`

Definition at line 135 of file OgrePanelOverlayElement.h.

bool Ogre::Renderable::mUseIdentityProjection`[protected, inherited]`

Definition at line 398 of file OgreRenderable.h.

bool Ogre::Renderable::mUseIdentityView`[protected, inherited]`

Definition at line 399 of file OgreRenderable.h.

UserObjectBindings Ogre::Renderable::mUserObjectBindings`[protected, inherited]`

Definition at line 400 of file OgreRenderable.h.

Real Ogre::PanelOverlayElement::mV1`[protected]`

Definition at line 135 of file OgrePanelOverlayElement.h.

Real Ogre::PanelOverlayElement::mV2`[protected]`

Definition at line 135 of file OgrePanelOverlayElement.h.

GuiVerticalAlignment Ogre::OverlayElement::mVertAlign`[protected, inherited]`

Definition at line 142 of file OgreOverlayElement.h.

bool Ogre::OverlayElement::mVisible`[protected, inherited]`

Definition at line 128 of file OgreOverlayElement.h.

Real Ogre::OverlayElement::mWidth`[protected, inherited]`

Definition at line 132 of file OgreOverlayElement.h.

Matrix4 Ogre::OverlayElement::mXForm`[protected, inherited]`

Definition at line 172 of file OgreOverlayElement.h.

ushort Ogre::OverlayElement::mZOrder`[protected, inherited]`

Definition at line 169 of file OgreOverlayElement.h.

The documentation for this class was generated from the following file:

- OgrePanelOverlayElement.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:57